package com.duanledexian.spring.cloud.order.controller;

import com.duanledexian.spring.cloud.order.api.IHelloApi;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.cloud.context.config.annotation.RefreshScope;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @author Administrator
 * <p>需要给加载变量的类上面加载 @RefreshScope，在客户端执行 /actuator/refresh 的时候就会更新此类下面的变量值。</p>
 */
@RestController
@RequestMapping("/api/v1")
@RefreshScope
@Slf4j
public class HomeController {
    @Autowired
    private IHelloApi helloApi;

    @Value("${hello.name:world}")
    private String name;

    @GetMapping("/sayHello")
    public String sayHello() {
        return helloApi.sayHello("order service");
    }

}
